/*
* ============================================================================
*  Name     : CSTTBaseData
*  Part of  : SymTorrentTest
*  Created  : 06.07.2006 by Zsolt Pszota 
*  Description:
*     
*  Version  :
*  Copyright: 
* ============================================================================
*/

#ifndef STTBASEDATA_H
#define STTBASEDATA_H

// INCLUDES
#include <e32base.h>
#include "STTTorrentListItem.h"

// CLASS DECLARATION

/**
*  CSTTBaseData class.
* 
*/
class CSTTBaseData : public CBase
{
    public: // Constructors and destructor

		IMPORT_C static CSTTBaseData* NewL();

        /**
        * Destructor.
        */
        IMPORT_C ~CSTTBaseData();

	protected:
        /**
        * EPOC default constructor.
        */
        void ConstructL();

		CSTTBaseData();

    public: // Functions from base classes

    public: // New functions
		// Getter and setter methods
		IMPORT_C TInt GetPartnerPort();
		IMPORT_C void SetPartnerPort(TInt aPartnerPort);
		IMPORT_C TInt GetServicePort();
		IMPORT_C void SetServicePort(TInt aServicePort);
		IMPORT_C TInt GetConnectionPort();
		IMPORT_C void SetConnectionPort(TInt aConnectionPort);
		IMPORT_C TPtr GetProxyAddress();
		IMPORT_C void SetProxyAddress(TPtrC aServerName);
		// Torrentfile list handling
		IMPORT_C CSTTTorrentListItem* InsertListItemL(TPtrC aTorrentFileName, TPtrC8 aInfoHash);
		IMPORT_C TBool DeleteListItem(TPtrC aTorrentFileName);
		IMPORT_C void DeleteAllListItem();
		IMPORT_C CSTTTorrentListItem* GetTorrentListFirstItem();


    private: // Data
		TInt						iPartnerPort;
		TInt						iServicePort;
		TInt						iConnectionPort;
		HBufC*						iProxyAddress;

		CSTTTorrentListItem*		iItemListHead;

};

#endif

// End of File
