#ifndef __IMEIINFOSUPPLIER_H__
#define __IMEIINFOSUPPLIER_H__

#include <etel3rdparty.h>

enum TImeiInfoSupplierState
{
	EWaitingForNotification = 0, // waiting for the change of the network info
	EGettingImeiInfo
};

class MImeiInfoObserver
{
	public:
		virtual void ImeiInfoReceivedL(CTelephony::TPhoneIdV1Pckg& aImeiInfo) = 0;
		virtual void GettingImeiFailedL() = 0;
};

class CImeiInfoSupplier : public CActive
{
public:

	static CImeiInfoSupplier* NewL();

	~CImeiInfoSupplier();
	
	inline void SetObserver(MImeiInfoObserver* aObserver);

private:
	CImeiInfoSupplier();
	void ConstructL();

public: // New functions
	void GetImeiInfoL();
	void Stop();
	
private: // From CActive
	void RunL();
	void DoCancel();
	
public:
	TImeiInfoSupplierState iState;
	
	CTelephony* iTelephony; 
	CTelephony::TPhoneIdV1 iPhoneId;
	CTelephony::TPhoneIdV1Pckg iPhoneIdPkg;
	
	MImeiInfoObserver* iObserver;
};

inline void CImeiInfoSupplier::SetObserver(MImeiInfoObserver* aObserver) {
	iObserver = aObserver;
}

#endif
