#ifndef __TIMEOUTHANDLER_H__
#define __TIMEOUTHANDLER_H__

#include <e32base.h>

enum TTimeOutHandlerState
{
	ETimerNotSet = 0, 
	ETimerWaiting,
	ETimerExpired
};

class MTimeOutObserver
{
	public:
		virtual void TimeOutExpired() = 0;
};

class CTimeOutHandler : public CActive
{
public:

	static CTimeOutHandler* NewL();

	~CTimeOutHandler();
	
	inline void SetObserver(MTimeOutObserver* aObserver);

private:
	CTimeOutHandler();
	void ConstructL();

public: // New functions
	void Start(TTimeIntervalMicroSeconds32 aTimeInterval);
	void Stop();
	
private: // From CActive
	void RunL();
	void DoCancel();
	
public:
	TTimeOutHandlerState		iState;
	MTimeOutObserver*			iObserver;
	RTimer						iTimer;
};

inline void CTimeOutHandler::SetObserver(MTimeOutObserver* aObserver) {
	iObserver = aObserver;
}

#endif
