/*
* ============================================================================
*  Name     : CSTTTorrentListItem
*  Part of  : SymTorrentTest
*  Created  : 08.01.2006 by Zsolt Pszota 
*  Description:
*     
*  Version  :
*  Copyright: 
* ============================================================================
*/

#ifndef STTTORRENTLISTITEM_H
#define STTTORRENTLISTITEM_H

// INCLUDES
#include <e32base.h>
#include "STTTorrentPeerItem.h"

// CLASS DECLARATION

/**
*  CSTTTorrentListItem class.
* 
*/
class CSTTTorrentListItem : public CBase
{
    public: // Constructors and destructor

		static CSTTTorrentListItem* NewL(TPtrC aTorrentFileName, TPtrC8 aInfoHash);

        /**
        * Destructor.
        */
        ~CSTTTorrentListItem();

	protected:
        /**
        * EPOC default constructor.
        */
        void ConstructL(TPtrC aTorrentFileName, TPtrC8 aInfoHash);

		CSTTTorrentListItem();

    public: // New functions
		TPtr GetTorrentFileName();
		void SetTorrentFileNameL(TPtrC aTorrentFileName);
		TPtr8 GetInfoHash();
		void SetInfoHashL(TPtrC8 aInfoHash);

		CSTTTorrentListItem* GetNextSibling();
		void SetNextSibling(CSTTTorrentListItem* aNextSibling);

		CSTTTorrentListItem* InsertAfterL(TPtrC aTorrentFileName, TPtrC8 aInfoHash);
		void DeleteNext();

		// Peer list handling
		CSTTTorrentPeerItem* InsertPeerItemL(TInetAddr aAddress, TDesC8& aId);
		TBool DeletePeerItem(TInetAddr aAddress, TDesC8& aId);
		void DeleteSimilarPeers(TInetAddr aAddress, TDesC8& aId);
		void DeleteAllPeerItem();
		CSTTTorrentPeerItem* GetPeerListFirstItem();
		CSTTTorrentPeerItem* FindPeerItem(TInetAddr aAddress, TDesC8& aId);
		void RemoveNeedlessPeers();


    private: // Data
		HBufC*						iTorrentFileName;
		HBufC8*						iInfoHash;

		CSTTTorrentListItem*		iNextSibling;

		CSTTTorrentPeerItem*		iPeerListHead;

};

#endif

// End of File
