/*
* ============================================================================
*  Name     : CSTTTorrentPeerItem
*  Part of  : SymTorrentTracker
*  Created  : 30.08.2006 by Zsolt Pszota 
*  Description:
*     
*  Version  :
*  Copyright: 
* ============================================================================
*/

#ifndef STTTORRENTPEERITEM_H
#define STTTORRENTPEERITEM_H

// INCLUDES
#include <e32base.h>
#include <in_sock.h>

// CLASS DECLARATION

/**
*  CSTTTorrentListItem class.
* 
*/
class CSTTTorrentPeerItem : public CBase
{
    public: // Constructors and destructor

		static CSTTTorrentPeerItem* NewL(TInetAddr aAddress, TDesC8& aId);

        /**
        * Destructor.
        */
        ~CSTTTorrentPeerItem();

	protected:
        /**
        * EPOC default constructor.
        */
        void ConstructL(TInetAddr aAddress, TDesC8& aId);

		CSTTTorrentPeerItem();

    public: // New functions

		CSTTTorrentPeerItem* GetNextSibling();
		void SetNextSibling(CSTTTorrentPeerItem* aNextSibling);

		CSTTTorrentPeerItem* InsertAfterL(TInetAddr aAddress, TDesC8& aId);
		void DeleteNext();

		void SetLastCheckInTime(TTime& aLastCheckInTime);
		TTime LastCheckInTime();
		void SetLastCheckInTimeNow();
		TInt SecondsFromLastCheckInTime();
		void SetCompleted(TBool aCompleted);
		TBool Completed();
		TBool PeerMatch(TInetAddr aAddress, TDesC8& aId);
		TUint32 Address();
		TInt Port();
		HBufC8* PeerId();
		HBufC8* PeerIp();

    private: // Data
		CSTTTorrentPeerItem*		iNextSibling;

		TInetAddr					iAddress;
		HBufC8*						iId;
		HBufC8*						iIp;
		TBool						iCompleted;
		TTime						iLastCheckInTime;

};

#endif

// End of File
