#include "STTImeiInfoSupplier.h"


CImeiInfoSupplier* CImeiInfoSupplier::NewL()
{
	CImeiInfoSupplier * self=new(ELeave) CImeiInfoSupplier();
	CleanupStack::PushL(self);
	self->ConstructL();
	CleanupStack::Pop();
	return self;
}

CImeiInfoSupplier::CImeiInfoSupplier() 
	: CActive(EPriorityStandard), 
		iPhoneIdPkg(iPhoneId), 
		iState(EWaitingForNotification)
{}

void CImeiInfoSupplier::ConstructL()
{
	iTelephony = CTelephony::NewL();
	CActiveScheduler::Add(this);
}

CImeiInfoSupplier::~CImeiInfoSupplier()
{
	Cancel(); // Cancel any request, if outstanding
	delete iTelephony;
}

void CImeiInfoSupplier::DoCancel()
{
	iTelephony->CancelAsync(CTelephony::EGetPhoneIdCancel);
}

void CImeiInfoSupplier::GetImeiInfoL()
{
	iTelephony->GetPhoneId(iStatus, iPhoneIdPkg);
	SetActive();
}

void CImeiInfoSupplier::Stop()
{
	Cancel();
}

void CImeiInfoSupplier::RunL()
{
	if (iStatus == KErrNone)
	{
		if (iObserver)
			iObserver->ImeiInfoReceivedL(iPhoneIdPkg);
	}
	else
		if (iObserver)
			iObserver->GettingImeiFailedL();
}
