#include "STTTimeOutHandler.h"

CTimeOutHandler* CTimeOutHandler::NewL()
{
	CTimeOutHandler * self=new(ELeave) CTimeOutHandler();
	CleanupStack::PushL(self);
	self->ConstructL();
	CleanupStack::Pop();
	return self;
}

CTimeOutHandler::CTimeOutHandler() 
	: CActive(EPriorityStandard), 
		iState(ETimerNotSet)
{}

void CTimeOutHandler::ConstructL()
{
	CActiveScheduler::Add(this);
	User::LeaveIfError(iTimer.CreateLocal());
}

CTimeOutHandler::~CTimeOutHandler()
{
	Cancel(); // Cancel any request, if outstanding
	iTimer.Close();
}

void CTimeOutHandler::DoCancel()
{
	iTimer.Cancel();
}

void CTimeOutHandler::Start(TTimeIntervalMicroSeconds32 aTimeInterval)
{
	iTimer.Cancel();
	iTimer.After(iStatus,aTimeInterval);
	iState = ETimerWaiting;
	SetActive();
}

void CTimeOutHandler::Stop()
{
	Cancel();
}

void CTimeOutHandler::RunL()
{
	iObserver->TimeOutExpired();
	iState = ETimerExpired;
}
