#ifndef CSTPEERARRAY_H_
#define CSTPEERARRAY_H_

#include <e32base.h>
#include "STPeer.h"
//class CSTPeer;

class RSTPeerArray
{
public:
	
	RSTPeerArray();
	
	virtual ~RSTPeerArray();
	
	inline void ResetAndDestroy();
	
	inline TInt Count() const;
	
	inline TInt LocalPeerCount() const;
	
	inline TInt PrimaryPeerCount() const;
	
	inline CSTPeer* operator[](TInt aIndex);
	
	inline TInt Find(CSTPeer* aPeer);
	
	void Close();
	
	void Remove(TInt aIndex);
	
	TInt Append(CSTPeer* aPeer);
	
	void AppendL(CSTPeer* aPeer);
	
private:
	
	RPointerArray<CSTPeer> iPeers;
	
	TInt iPrimaryPeerCount;
	TInt iLocalPeerCount;
};

inline void RSTPeerArray::ResetAndDestroy() {
	iPeers.ResetAndDestroy();
}

inline TInt RSTPeerArray::Count() const {
	return iPeers.Count();
}

inline TInt RSTPeerArray::LocalPeerCount() const {
	return iLocalPeerCount;
}

inline TInt RSTPeerArray::PrimaryPeerCount() const {
	return iPrimaryPeerCount;
}

inline CSTPeer* RSTPeerArray::operator[](TInt aIndex) {
	return iPeers[aIndex];
}

inline TInt RSTPeerArray::Find(CSTPeer* aPeer) {
	return iPeers.Find(aPeer);
}

#endif /*CSTPEERARRAY_H_*/
