#include "STPeerArray.h"
#include "STPeer.h"

RSTPeerArray::RSTPeerArray()
 : iPrimaryPeerCount(0), iLocalPeerCount(0)
{
}

RSTPeerArray::~RSTPeerArray()
{
	iPeers.ResetAndDestroy();
}

void RSTPeerArray::Close()
{
	iPeers.ResetAndDestroy();
}

void RSTPeerArray::Remove(TInt aIndex) 
{
	if (iPeers[aIndex]->IsLocal())
		iLocalPeerCount--;
	else
		iPrimaryPeerCount--;
	
	iPeers.Remove(aIndex);
}

TInt RSTPeerArray::Append(CSTPeer* aPeer)
{
	TInt res = iPeers.Append(aPeer);
	
	if (res == KErrNone)
	{
		if (aPeer->IsLocal())
			iLocalPeerCount++;
		else
			iPrimaryPeerCount++;
	}
	
	return res;
}

void RSTPeerArray::AppendL(CSTPeer* aPeer)
{
	User::LeaveIfError(Append(aPeer));
}
