/*****************************************************************************
 * Copyright (C) 2006 Imre Kelnyi
 *-------------------------------------------------------------------
 * This file is part of SymTorrent
 *
 * SymTorrent is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * SymTorrent is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Symella; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *****************************************************************************/
 
#ifndef SYMTORRENT_STLOGGER_H
#define SYMTORRENT_STLOGGER_H

// uncomment the next line if you want to have 
// the log saved into a file
#ifdef __WINS__
#define LOG_TO_FILE
#endif

#include <coemain.h>

#define LOG CLogger::InstanceL()

	const TUid KUidLoggerSingleton = { 0x10000EF4 };

	/**
	 * Observer class for handling events generated by CLogger
	 */
	class MLogObserver
	{
	public:

		/**
		 * Called when text is added to the log.
		 */
		virtual void HandleLogWriteL(const TDesC& aText) = 0;
	};


	/**
	 * CLogger
	 */
	class CLogger : public CCoeStatic
	{
	public:

		static CLogger* InstanceL();

		~CLogger();

		void ConstructL();

		void SetObserver(MLogObserver* aObserver);

		void WriteL(const TDesC& aText);

		void WriteL(const TDesC8& aText);

		void WriteLineL(const TDesC& aText);

		void WriteLineL(const TDesC8& aText);

		void WriteLineL();

		void WriteL(TInt aInt);

		void WriteLineL(TInt aInt);


	protected:

		CLogger() : CCoeStatic(KUidLoggerSingleton) {}

	private:

		RFs iFsSession;

		RFile iLogFile;

		MLogObserver* iObserver;
	};


	inline void CLogger::SetObserver(MLogObserver* aObserver) {
		iObserver = aObserver;
	}

#endif
