/*****************************************************************************
 * Copyright (C) 2006 Imre Kelnyi
 *-------------------------------------------------------------------
 * This file is part of SymTorrent
 *
 * SymTorrent is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * SymTorrent is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Symella; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *****************************************************************************/
 
/* ====================================================================
 * File: SymTorrentLauncherAppUi.h
 * Created: 06/11/06
 * ==================================================================== */

#ifndef __SYMTORRENTLAUNCHER_APPUI_H__
#define __SYMTORRENTLAUNCHER_APPUI_H__

#include <aknappui.h>

// Forward reference
class CSymTorrentLauncherAppView;

/*! 
  @class CSymTorrentLauncherAppUi
  
  @discussion An instance of class CSymTorrentLauncherAppUi is the UserInterface part of the AVKON
  application framework for the SymTorrentLauncher example application
  */
class CSymTorrentLauncherAppUi : public CAknAppUi
    {
public:
/*!
  @function ConstructL
  
  @discussion Perform the second phase construction of a CSymTorrentLauncherAppUi object
  this needs to be public due to the way the framework constructs the AppUi 
  */
    void ConstructL();

/*!
  @function CSymTorrentLauncherAppUi
  
  @discussion Perform the first phase of two phase construction.
  This needs to be public due to the way the framework constructs the AppUi 
  */
    CSymTorrentLauncherAppUi();


/*!
  @function ~CSymTorrentLauncherAppUi
  
  @discussion Destroy the object and release all memory objects
  */
    ~CSymTorrentLauncherAppUi();


public: // from CAknAppUi
/*!
  @function HandleCommandL
  
  @discussion Handle user menu selections
  @param aCommand the enumerated code for the option selected
  */
    void HandleCommandL(TInt aCommand);
    
private:

	TBool ProcessCommandParametersL(TApaCommand aCommand,TFileName& aDocumentName,const TDesC8& aTail);
	
	//TBool ProcessCommandParametersL(TApaCommand aCommand,TFileName& aDocumentName);



private:
/*! @var iAppView The application view */
    CSymTorrentLauncherAppView* iAppView;
    };


#endif // __SYMTORRENTLAUNCHER_APPUI_H__

