/*****************************************************************************
 * Copyright (C) 2006 Imre Kelnyi
 *-------------------------------------------------------------------
 * This file is part of SymTorrent
 *
 * SymTorrent is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * SymTorrent is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Symella; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *****************************************************************************/
 
/* ====================================================================
 * File: SymTorrentLauncherAppView.h
 * Created: 06/11/06
 * ==================================================================== */

#ifndef __SYMTORRENTLAUNCHER_APPVIEW_H__
#define __SYMTORRENTLAUNCHER_APPVIEW_H__


#include <coecntrl.h>

/*! 
  @class CSymTorrentLauncherAppView
  
  @discussion An instance of the Application View object for the SymTorrentLauncher 
  example application
  */
class CSymTorrentLauncherAppView : public CCoeControl
    {
public:

/*!
  @function NewL
   
  @discussion Create a CSymTorrentLauncherAppView object, which will draw itself to aRect
  @param aRect the rectangle this view will be drawn to
  @result a pointer to the created instance of CSymTorrentLauncherAppView
  */
    static CSymTorrentLauncherAppView* NewL(const TRect& aRect);

/*!
  @function NewLC
   
  @discussion Create a CSymTorrentLauncherAppView object, which will draw itself to aRect
  @param aRect the rectangle this view will be drawn to
  @result a pointer to the created instance of CSymTorrentLauncherAppView
  */
    static CSymTorrentLauncherAppView* NewLC(const TRect& aRect);


/*!
  @function ~CSymTorrentLauncherAppView
  
  @discussion Destroy the object and release all memory objects
  */
     ~CSymTorrentLauncherAppView();


public:  // from CCoeControl
/*!
  @function Draw
  
  @discussion Draw this CSymTorrentLauncherAppView to the screen
  @param aRect the rectangle of this view that needs updating
  */
    void Draw(const TRect& aRect) const;
  

private:

/*!
  @function ConstructL
  
  @discussion  Perform the second phase construction of a CSymTorrentLauncherAppView object
  @param aRect the rectangle this view will be drawn to
  */
    void ConstructL(const TRect& aRect);

/*!
  @function CSymTorrentLauncherAppView
  
  @discussion Perform the first phase of two phase construction 
  */
    CSymTorrentLauncherAppView();
    };


#endif // __SYMTORRENTLAUNCHER_APPVIEW_H__
