/*****************************************************************************
 * Copyright (C) 2006 Imre Kelnyi
 *-------------------------------------------------------------------
 * This file is part of SymTorrent
 *
 * SymTorrent is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * SymTorrent is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Symella; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *****************************************************************************/
 
/* ====================================================================
 * File: SymTorrentLauncherAppUi.cpp
 * Created: 06/11/06
 * ==================================================================== */

#include <avkon.hrh>
#include <aknnotewrappers.h> 
#include <apparc.h>
#include <akndoc.h>

#include "SymTorrentLauncher.pan"
#include "SymTorrentLauncherAppUi.h"
#include "SymTorrentLauncherAppView.h"
#include "SymTorrentLauncher.hrh"
#include "STLogger.h"

// ConstructL is called by the application framework
void CSymTorrentLauncherAppUi::ConstructL()
    {
    BaseConstructL();

    iAppView = CSymTorrentLauncherAppView::NewL(ClientRect());    

    AddToStackL(iAppView);
    }

CSymTorrentLauncherAppUi::CSymTorrentLauncherAppUi()                              
    {
	// no implementation required
    }

CSymTorrentLauncherAppUi::~CSymTorrentLauncherAppUi()
    {
    if (iAppView)
        {
        RemoveFromStack(iAppView);
        delete iAppView;
        iAppView = NULL;
        }
    }

// handle any menu commands
void CSymTorrentLauncherAppUi::HandleCommandL(TInt aCommand)
    {
    switch(aCommand)
        {
        case EEikCmdExit:
        case EAknSoftkeyExit:
        	if (iDoorObserver)
				iDoorObserver->NotifyExit(MApaEmbeddedDocObserver::ENoChanges);
            Exit();
            break;

        default:
            Panic(ESymTorrentLauncherBasicUi);
            break;
        }
    }


TBool CSymTorrentLauncherAppUi::ProcessCommandParametersL(TApaCommand aCommand,TFileName& aDocumentName,const TDesC8& aTail)
{
	LOG->WriteL(_L("Process command: "));
	LOG->WriteLineL(aDocumentName);
	if (aDocumentName.Length() > 0)
	{	
		static_cast<CAknDocument*>(Document())
			->OpenFileL(ETrue, aDocumentName, CEikonEnv::Static()->FsSession());
			
		return ETrue;
	}
	else
		return CAknAppUi::ProcessCommandParametersL(aCommand, aDocumentName, aTail);
}

