/*****************************************************************************
 * Copyright (C) 2006 Imre Kelnyi
 *-------------------------------------------------------------------
 * This file is part of SymTorrent
 *
 * SymTorrent is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * SymTorrent is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Symella; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *****************************************************************************/
 
/* ====================================================================
 * File: SymTorrentLauncherAppView.cpp
 * Created: 06/11/06
 * ==================================================================== */

#include <coemain.h>
#include <SymTorrentLauncher.rsg>

#include "SymTorrentLauncherAppView.h"

// Standard construction sequence
CSymTorrentLauncherAppView* CSymTorrentLauncherAppView::NewL(const TRect& aRect)
    {
    CSymTorrentLauncherAppView* self = CSymTorrentLauncherAppView::NewLC(aRect);
    CleanupStack::Pop(self);
    return self;
    }

CSymTorrentLauncherAppView* CSymTorrentLauncherAppView::NewLC(const TRect& aRect)
    {
    CSymTorrentLauncherAppView* self = new (ELeave) CSymTorrentLauncherAppView;
    CleanupStack::PushL(self);
    self->ConstructL(aRect);
    return self;
    }

CSymTorrentLauncherAppView::CSymTorrentLauncherAppView()
    {
	// no implementation required
    }

CSymTorrentLauncherAppView::~CSymTorrentLauncherAppView()
    {
	// no implementation required
    }

void CSymTorrentLauncherAppView::ConstructL(const TRect& aRect)
    {
    // Create a window for this application view
    CreateWindowL();

    // Set the windows size
    SetRect(aRect);

    // Activate the window, which makes it ready to be drawn
    ActivateL();
    }

// Draw this application's view to the screen
void CSymTorrentLauncherAppView::Draw(const TRect& /*aRect*/) const
    {
    // Get the standard graphics context 
    CWindowGc& gc = SystemGc();
    
    // Gets the control's extent
    TRect rect = Rect();
    
    // Clears the screen
    gc.Clear(rect);
    }


