/*****************************************************************************
 * Copyright (C) 2006 Pter Ekler, Zsolt Pszota
 * ---------------------------------------------------------------------------
 * This file is part of SymTracker
 *
 * SymTracker is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * SymTracker is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with SymTracker; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *****************************************************************************/


// This file defines the API for SymTorrentMakerDll.dll

#ifndef __SYMTORRENTMAKERDLL_H__
#define __SYMTORRENTMAKERDLL_H__


//  Include Files

#include <e32base.h>    // CBase
#include <e32std.h>     // TBuf
#include "TorrentMaker.h"


//  Constants

const TInt KSymTorrentMakerDllBufferLength = 15;
typedef TBuf<KSymTorrentMakerDllBufferLength> TSymTorrentMakerDllExampleString;


//  Class Definitions

class CSymTorrentMakerDll : public CTorrentMaker
    {
    public:     // new functions
        IMPORT_C static CSymTorrentMakerDll* NewL();
        IMPORT_C static CSymTorrentMakerDll* NewLC();
//        IMPORT_C ~CSymTorrentMakerDll();

    public:     // new functions, example API
        IMPORT_C TVersion Version() const;

		IMPORT_C void SetAnnounceUrl(TDesC &aNewAnnounceUrl);
		IMPORT_C void GetAnnounceUrlInto(TDes &aAnnounceUrl);

		IMPORT_C void SetPieceSizeInKilobytes(TInt aNewPieceSize); 
		IMPORT_C TInt GetPieceSizeInKilobytes();

		IMPORT_C TErrorCode AddFileL(TDesC &aFilename);
		IMPORT_C TErrorCode AddFileL(TDesC &aFilename, TDesC &aVirtualFilename);

		IMPORT_C TErrorCode SaveTorrentL(TDesC &aTorrentFilename, TBool aSaveSTorrent);

/*
        IMPORT_C void ExampleFuncAddCharL(const TChar& aChar);
        IMPORT_C void ExampleFuncRemoveLast();
        IMPORT_C const TPtrC ExampleFuncString() const;
*/
    private:    // new functions
//        CSymTorrentMakerDll();

    private:    // data
/*
        TSymTorrentMakerDllExampleString* iString;
*/
    };


#endif  // __SYMTORRENTMAKERDLL_H__


