/*****************************************************************************
 * Copyright (C) 2006 Pter Ekler, Zsolt Pszota
 * ---------------------------------------------------------------------------
 * This file is part of SymTracker
 *
 * SymTracker is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * SymTracker is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with SymTracker; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *****************************************************************************/

//  Include Files  

#include "SymTorrentMakerDll.h"	// CSymTorrentMakerDll
#include "SymTorrentMakerDll.pan"      	// panic codes


//  Member Functions

EXPORT_C CSymTorrentMakerDll* CSymTorrentMakerDll::NewLC()
{
    CSymTorrentMakerDll* self = new (ELeave) CSymTorrentMakerDll;
    CleanupStack::PushL(self);
    self->ConstructL();
    return self;
}


EXPORT_C CSymTorrentMakerDll* CSymTorrentMakerDll::NewL()
{
    CSymTorrentMakerDll* self = CSymTorrentMakerDll::NewLC();
    CleanupStack::Pop(self);
    return self;
}

EXPORT_C TVersion CSymTorrentMakerDll::Version() const
{
    // Version number of example API
    const TInt KMajor = 1;
    const TInt KMinor = 0;
    const TInt KBuild = 1;
    return TVersion(KMajor, KMinor, KBuild);
}


EXPORT_C void CSymTorrentMakerDll::SetAnnounceUrl(TDesC &aNewAnnounceUrl)
{
	CTorrentMaker::SetAnnounceUrl(aNewAnnounceUrl);
}

EXPORT_C void CSymTorrentMakerDll::GetAnnounceUrlInto(TDes &aAnnounceUrl)
{
	CTorrentMaker::GetAnnounceUrlInto(aAnnounceUrl);
}

EXPORT_C void CSymTorrentMakerDll::SetPieceSizeInKilobytes(TInt aNewPieceSize)
{
	CTorrentMaker::SetPieceSizeInKilobytes(aNewPieceSize);
}

EXPORT_C TInt CSymTorrentMakerDll::GetPieceSizeInKilobytes()
{
	return CTorrentMaker::GetPieceSizeInKilobytes();
}

EXPORT_C TErrorCode CSymTorrentMakerDll::AddFileL(TDesC &aFilename)
{
	return CTorrentMaker::AddFileL(aFilename);
}

EXPORT_C TErrorCode CSymTorrentMakerDll::AddFileL(TDesC &aFilename, TDesC &aVirtualFilename)
{
	return CTorrentMaker::AddFileL(aFilename, aVirtualFilename);
}

EXPORT_C TErrorCode CSymTorrentMakerDll::SaveTorrentL(TDesC &aTorrentFilename, TBool aSaveSTorrent)
{
	return CTorrentMaker::SaveTorrentL(aTorrentFilename, aSaveSTorrent);
}
