/*****************************************************************************
 * Copyright (C) 2006 Pter Ekler, Zsolt Pszota
 * ---------------------------------------------------------------------------
 * This file is part of SymTracker
 *
 * SymTracker is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * SymTracker is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with SymTracker; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *****************************************************************************/

// INCLUDE FILES
#include "TorrentMaker.h"

// ================= MEMBER FUNCTIONS =======================
//
// ----------------------------------------------------------
// CSymTorrentMakerAppUi::ConstructL()
// 
// ----------------------------------------------------------
//
void CSTMPackage::ConstructL()
{
	iTorrentFileName.Copy(_L(""));
	iTorrentSavePath.Copy(_L(""));
	iAnnounceUrl.Copy(_L(""));
	iRootNode = CSTMPackageNode::NewL(_L("root"),_L(""),EFolderNode,NULL);
	iPieceSize = 64;
}

EXPORT_C CSTMPackage::~CSTMPackage()
{
	delete iRootNode;
}

CSTMPackage* CSTMPackage::NewL()
{
	CSTMPackage * self=new(ELeave) CSTMPackage();
	CleanupStack::PushL(self);
	self->ConstructL();
	CleanupStack::Pop();
	return self;
}

EXPORT_C void CSTMPackage::SetTorrentFileName(const TDesC &aNewFileName)
{
	iTorrentFileName.Copy(aNewFileName);
}

EXPORT_C void CSTMPackage::GetTorrentFileNameInto(TDes &aFileName)
{
	aFileName.Copy(iTorrentFileName);
}

EXPORT_C void CSTMPackage::SetTorrentSavePath(const TDesC &aNewSavePath)
{
	iTorrentSavePath.Copy(aNewSavePath);
}

void CSTMPackage::GetTorrentSavePathInto(TDes &aSavePath)
{
	aSavePath.Copy(iTorrentSavePath);
}

EXPORT_C void CSTMPackage::SetAnnounceUrl(const TDesC &aNewAnnounceUrl)
{
	iAnnounceUrl.Copy(aNewAnnounceUrl);
}

EXPORT_C void CSTMPackage::GetAnnounceUrlInto(TDes &aAnnounceUrl)
{
	aAnnounceUrl.Copy(iAnnounceUrl);
}

EXPORT_C void CSTMPackage::SetPieceSize(TInt aNewPieceSize)
{
	iPieceSize = aNewPieceSize;
}

EXPORT_C TInt CSTMPackage::GetPieceSize()
{
	return iPieceSize;
}

EXPORT_C CSTMPackageNode* CSTMPackage::GetRootNode()
{
	return iRootNode;
}
