/*****************************************************************************
 * Copyright (C) 2006 Pter Ekler, Zsolt Pszota
 * ---------------------------------------------------------------------------
 * This file is part of SymTracker
 *
 * SymTracker is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * SymTracker is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with SymTracker; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *****************************************************************************/

// INCLUDE FILES
#include "TorrentMaker.h"


// ================= MEMBER FUNCTIONS =======================
//
// ----------------------------------------------------------
// CTorrentMaker::ConstructL()
// 
// ----------------------------------------------------------
//
void CTorrentMaker::ConstructL()
{
	CSTMTorrentHandler::ConstructL();
}


CTorrentMaker* CTorrentMaker::NewL()
{
	CTorrentMaker * self=new(ELeave) CTorrentMaker();
	CleanupStack::PushL(self);
	self->ConstructL();
	CleanupStack::Pop();
	return self;
}

void CTorrentMaker::SetAnnounceUrl(const TDesC &aNewAnnounceUrl)
{
	iTorrentPackage->SetAnnounceUrl(aNewAnnounceUrl);
}

void CTorrentMaker::GetAnnounceUrlInto(TDes &aAnnounceUrl)
{
	iTorrentPackage->GetAnnounceUrlInto(aAnnounceUrl);
}

void CTorrentMaker::SetPieceSizeInKilobytes(TInt aNewPieceSize)
{
	iTorrentPackage->SetPieceSize(aNewPieceSize);
}

TInt CTorrentMaker::GetPieceSizeInKilobytes()
{
	return iTorrentPackage->GetPieceSize();
}

TErrorCode CTorrentMaker::AddFileL(const TDesC &aFilename)
{
	TBuf<256> chosenfile;
	TBuf<200> listitem;
	TInt lastocc;
	chosenfile.Copy(aFilename);
	lastocc=chosenfile.LocateReverse('\\');
	if (lastocc==KErrNotFound) lastocc=-1;
	TPtrC16 shortname=chosenfile.Right(chosenfile.Length()-(lastocc+1));
	if (iTorrentPackage->GetRootNode()->AddChild(shortname,chosenfile,EFileNode)==NULL)
		return EFileAlreadyExists;
	else
		return ESucceed;
}

TErrorCode CTorrentMaker::AddFileL(const TDesC &aFilename, const TDesC &aVirtualFilename)
{
	TBuf<256> temppath;
	TBuf<256> item;
	TInt occ;
	CSTMPackageNode* currentfolder = iTorrentPackage->GetRootNode();
	CSTMPackageNode* temp;

	temppath.Copy(aVirtualFilename);
	while ((occ=temppath.Locate('\\'))!=KErrNotFound)
	{
		item = temppath.Left(occ);
		temppath = temppath.Right(temppath.Length()-(occ+1));

		currentfolder = currentfolder->AddAndReturnChild(item,item,EFolderNode);
	}

	if (currentfolder->AddChild(temppath,aFilename,EFileNode)==NULL)
		return EFileAlreadyExists;
	else
		return ESucceed;
    
	return ESucceed;
}

TErrorCode CTorrentMaker::SaveTorrentL(const TDesC &aTorrentFilename, TBool aSaveSTorrent)
{
	TBuf<2> empty;
	empty.Copy(_L(""));
	iTorrentPackage->SetTorrentSavePath(empty);
	iTorrentPackage->SetTorrentFileName(aTorrentFilename);
	SaveTorrent(aSaveSTorrent);
	return ESucceed;
}