/*****************************************************************************
 * Copyright (C) 2006 Pter Ekler, Zsolt Pszota
 * ---------------------------------------------------------------------------
 * This file is part of SymTracker
 *
 * SymTracker is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * SymTracker is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with SymTracker; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *****************************************************************************/

#ifndef STTBASEDATA_H
#define STTBASEDATA_H

// INCLUDES
#include <e32base.h>

// FORWARD DECLARATIONS
class CSTTTorrentListItem;
class MSTTTorrentItemObserver;

// CLASS DECLARATION

/**
*  CSTTBaseData class.
* 
*/
class CSTTBaseData : public CBase
{
    public: // Constructors and destructor

		static CSTTBaseData* NewL();

        /**
        * Destructor.
        */
        ~CSTTBaseData();

	protected:
        /**
        * EPOC default constructor.
        */
        void ConstructL();

		CSTTBaseData();

    public: // Functions from base classes

    public: // New functions
		// Getter and setter methods
		void SetTorrentObserver(MSTTTorrentItemObserver* aTorrentObserver);
		TInt GetPartnerPort();
		void SetPartnerPort(TInt aPartnerPort);
		// Torrentfile list handling
		CSTTTorrentListItem* InsertListItemL(TPtrC aTorrentFileName, TPtrC8 aInfoHash);
		TBool DeleteListItem(TPtrC aTorrentFileName);
		void DeleteAllListItem();
		CSTTTorrentListItem* GetTorrentListFirstItem();


    private: // Data
		TInt						iPartnerPort;

		CSTTTorrentListItem*		iItemListHead;
		MSTTTorrentItemObserver*	iTorrentObserver;

};

#endif

// End of File
