/*****************************************************************************
 * Copyright (C) 2006 Pter Ekler, Zsolt Pszota
 * ---------------------------------------------------------------------------
 * This file is part of SymTracker
 *
 * SymTracker is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * SymTracker is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with SymTracker; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *****************************************************************************/

#ifndef STTCONNECTIONSOCKETCOLLECTOR_H
#define STTCONNECTIONSOCKETCOLLECTOR_H

// INCLUDES
#include <e32base.h>
#include <es_sock.h>
#include <in_sock.h>

#include "STTSocketCollector.h"
#include "SymTorrentTrackerManager.h"
#include "STTServiceSocket.h"


/**
*  CSTTHTTPSocketCollector class.
* 
*/
class CSTTConnectionSocketCollector : public CBase, public MSTTSocketCollector
    {
    public: // Constructors and destructor

		static CSTTConnectionSocketCollector* NewL();

        /**
        * Destructor.
        */
        ~CSTTConnectionSocketCollector();

	protected:
        /**
        * EPOC default constructor.
        */
        void ConstructL();

		CSTTConnectionSocketCollector();

    public: // Functions from base classes
		void Initialize(CSymTorrentTrackerManager* aTrackerManager); 
		void Accept(RSocket* aInitializedSocket, TInetAddr &aPartnerAddress); 
		void CheckAndAddNewSocket(RSocket* aInitializedSocket, TInetAddr &aPartnerAddress);
		void ReleaseAllSocket();

	private:
		CSymTorrentTrackerManager*      iTrackerManager;
		CSTTServiceSocket*				iFirstSocket;
    };

#endif

// End of File
