/*****************************************************************************
 * Copyright (C) 2006 Pter Ekler, Zsolt Pszota
 * ---------------------------------------------------------------------------
 * This file is part of SymTracker
 *
 * SymTracker is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * SymTracker is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with SymTracker; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *****************************************************************************/

#ifndef __IMEIINFOSUPPLIER_H__
#define __IMEIINFOSUPPLIER_H__

#include <etel3rdparty.h>

enum TImeiInfoSupplierState
{
	EWaitingForNotification = 0, // waiting for the change of the network info
	EGettingImeiInfo
};

class MImeiInfoObserver
{
	public:
		virtual void ImeiInfoReceivedL(CTelephony::TPhoneIdV1Pckg& aImeiInfo) = 0;
		virtual void GettingImeiFailedL() = 0;
};

class CImeiInfoSupplier : public CActive
{
public:

	static CImeiInfoSupplier* NewL();

	~CImeiInfoSupplier();
	
	inline void SetObserver(MImeiInfoObserver* aObserver);

private:
	CImeiInfoSupplier();
	void ConstructL();

public: // New functions
	void GetImeiInfoL();
	void Stop();
	
private: // From CActive
	void RunL();
	void DoCancel();
	
public:
	TImeiInfoSupplierState iState;
	
	CTelephony* iTelephony; 
	CTelephony::TPhoneIdV1 iPhoneId;
	CTelephony::TPhoneIdV1Pckg iPhoneIdPkg;
	
	MImeiInfoObserver* iObserver;
};

inline void CImeiInfoSupplier::SetObserver(MImeiInfoObserver* aObserver) {
	iObserver = aObserver;
}

#endif
