/*****************************************************************************
 * Copyright (C) 2006 Pter Ekler, Zsolt Pszota
 * ---------------------------------------------------------------------------
 * This file is part of SymTracker
 *
 * SymTracker is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * SymTracker is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with SymTracker; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *****************************************************************************/

#ifndef __TIMEOUTHANDLER_H__
#define __TIMEOUTHANDLER_H__

#include <e32base.h>

enum TTimeOutHandlerState
{
	ETimerNotSet = 0, 
	ETimerWaiting,
	ETimerExpired
};

class MTimeOutObserver
{
	public:
		virtual void TimeOutExpired() = 0;
};

class CTimeOutHandler : public CActive
{
public:

	static CTimeOutHandler* NewL();

	~CTimeOutHandler();
	
	inline void SetObserver(MTimeOutObserver* aObserver);

private:
	CTimeOutHandler();
	void ConstructL();

public: // New functions
	void Start(TTimeIntervalMicroSeconds32 aTimeInterval);
	void Stop();
	
private: // From CActive
	void RunL();
	void DoCancel();
	
public:
	TTimeOutHandlerState		iState;
	MTimeOutObserver*			iObserver;
	RTimer						iTimer;
};

inline void CTimeOutHandler::SetObserver(MTimeOutObserver* aObserver) {
	iObserver = aObserver;
}

#endif
