/*****************************************************************************
 * Copyright (C) 2006 Pter Ekler, Zsolt Pszota
 * ---------------------------------------------------------------------------
 * This file is part of SymTracker
 *
 * SymTracker is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * SymTracker is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with SymTracker; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *****************************************************************************/

#include "STTImeiInfoSupplier.h"

CImeiInfoSupplier* CImeiInfoSupplier::NewL()
{
	CImeiInfoSupplier * self=new(ELeave) CImeiInfoSupplier();
	CleanupStack::PushL(self);
	self->ConstructL();
	CleanupStack::Pop();
	return self;
}

CImeiInfoSupplier::CImeiInfoSupplier() 
	: CActive(EPriorityStandard), 
		iPhoneIdPkg(iPhoneId), 
		iState(EWaitingForNotification)
{}

void CImeiInfoSupplier::ConstructL()
{
	iTelephony = CTelephony::NewL();
	CActiveScheduler::Add(this);
}

CImeiInfoSupplier::~CImeiInfoSupplier()
{
	Cancel(); // Cancel any request, if outstanding
	delete iTelephony;
}

void CImeiInfoSupplier::DoCancel()
{
	iTelephony->CancelAsync(CTelephony::EGetPhoneIdCancel);
}

void CImeiInfoSupplier::GetImeiInfoL()
{
	iTelephony->GetPhoneId(iStatus, iPhoneIdPkg);
	SetActive();
}

void CImeiInfoSupplier::Stop()
{
	Cancel();
}

void CImeiInfoSupplier::RunL()
{
	if (iStatus == KErrNone)
	{
		if (iObserver)
			iObserver->ImeiInfoReceivedL(iPhoneIdPkg);
	}
	else
		if (iObserver)
			iObserver->GettingImeiFailedL();
}
