/*****************************************************************************
 * Copyright (C) 2006 Imre Kelnyi
 *-------------------------------------------------------------------
 * This file is part of SymTorrent
 *
 * SymTorrent is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * SymTorrent is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Symella; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *****************************************************************************/
 
#ifdef EKA2
#include <ImplementationProxy.h>
#endif // EKA2

#include <TorrentRecognizer.h>
//#include <AppStarter.h>

CTorrentRecognizer::CTorrentRecognizer() :
	CApaDataRecognizerType(KUidRecognizer,EHigh)
{
	iCountDataTypes = 1;
	//TAppStarter::StartAsync();
}

TUint CTorrentRecognizer::PreferredBufSize()
{
	return 10;
}

TDataType CTorrentRecognizer::SupportedDataTypeL(TInt aIndex) const
{
	switch (aIndex)
	{
		case 0: 
		default: 
			return TDataType(KTorrentType);
			//return TDataType();
	}
}

void CTorrentRecognizer::DoRecognizeL(const TDesC &aName, const TDesC8 &/*aBuffer*/)
{
	iConfidence = ECertain;

	TFileName name=aName;
	name.LowerCase();

	if (name.Right(KTorrentExtension().Length()) == KTorrentExtension)
	{ 
		iDataType = TDataType(KTorrentType); 
		return; 
	}

	iConfidence=ENotRecognized;
	iDataType=TDataType();
}

#ifdef EKA2

const TInt KTorrentRecognizerImplementationUid = 0x1983190C;

const TImplementationProxy ImplementationTable[] =
{
    IMPLEMENTATION_PROXY_ENTRY(KTorrentRecognizerImplementationUid, CTorrentRecognizer::CreateRecognizerL)
};

EXPORT_C const TImplementationProxy* ImplementationGroupProxy(TInt& aTableCount)
{
    aTableCount = sizeof(ImplementationTable) / sizeof(TImplementationProxy);
    return ImplementationTable;
}

CApaDataRecognizerType* CTorrentRecognizer::CreateRecognizerL()
{
	return new (ELeave) CTorrentRecognizer;
}

#endif // EKA2
